=== debian/changelog ===
wxmaxima (26.01.0+ds-2) unstable; urgency=medium

  * Debianization:
    Now gather documents and examples in the dedicated package wxmaxima-doc.
    - d/copyright:
      - Copyright entry for cmake-bin2h, introduce;
    - d/control:
      - Build-Depends-Indep field, introduce;
      - Package wxmaxima-doc, introduce;
    - d/patches/*:
      - d/p/debianization.patch, enhance;
    - d/rules: harden;
    - d/*: debhelper files, introduce.

 -- Jerome Benoit <calculus@rezozer.net>  Thu, 12 Feb 2026 22:40:16 +0000

wxmaxima (26.01.0+ds-1) unstable; urgency=medium

  * New upstream version.
  * Debianization:
    - d/control:
      - Maintainer field, set to 'Debian Science Maintainers';
      - Uploaders field, add the former Maintainer and myself;
      - Vcs-{Git,Browser}, move to Salsa;
      - Homepage field, secure;
      - Priority field, now rely on the default (optional);
      - Rules-Requires-Root, now rely on default (no);
      - Standards-Version, bump to 4.7.3 (no change);
      - Build-Depends field, harden;
    - d/copyright:
      - copyright year-tuples, update;
      - Files-Excluded, introduce;
    - d/patches/*:
      - d/p/README.patches, discard;
      - d/p/upstream-fix-cmake-file_relativepath.patch, introduce;
      - d/p/debianization.patch, introduce;
    - d/watch, refresh;
    - d/gbp.conf, discard;
    - d/dephelper-compat, discard.

 -- Jerome Benoit <calculus@rezozer.net>  Tue, 10 Feb 2026 23:57:01 +0000
