=== debian/control ===
Source: wxmaxima
Section: math
Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Jerome Benoit <calculus@rezozer.net>,
           Gunter Königsmann <wxmaxima@physikbuch.de>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libwxgtk3.2-dev,
 maxima,
 po4a,
 appstream,
 xvfb,
 netcat-openbsd,
 xauth,
 desktop-file-utils,
 appstream-util,
 libwxgtk-webview3.2-dev
Build-Depends-Indep:
 pandoc,
 imagemagick,
 texlive-latex-base,
 texlive-latex-extra,
 texlive-xetex,
 lmodern,
 texlive-fonts-recommended,
 texlive-fonts-extra-links,
 texlive-lang-cjk,
 texlive-lang-chinese,
 fonts-noto-cjk
Standards-Version: 4.7.3
Homepage: https://wxmaxima-developers.github.io/wxmaxima/
Vcs-Git: https://salsa.debian.org/science-team/wxmaxima.git
Vcs-Browser: https://salsa.debian.org/science-team/wxmaxima

Package: wxmaxima
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, maxima
Recommends: maxima-doc
Suggests: fonts-jsmath, texlive-latex-extra, ibus-gtk3
Description: GUI for the computer algebra system Maxima
 wxMaxima is a graphical user interface for the computer algebra system
 Maxima. It eases the use of Maxima by making most of its commands available
 through a menu system and by providing input dialogs for commands that
 require more than one argument. It also implements its own display engine
 that outputs mathematical symbols directly instead of depicting them with
 ASCII characters.
 .
 wxMaxima also features 2D and 3D inline plots, simple animations, mixing of
 text and mathematical calculations to create documents, exporting of input
 and output to TeX, and a browser for Maxima's manual including command index
 and full text searching.

Package: wxmaxima-doc
Architecture: all
Depends: ${misc:Depends}
Recommends: maxima-doc
Suggests: pdf-viewer, www-browser
Enhances: wxmaxima
Description: GUI for the computer algebra system Maxima -- documentation
 wxMaxima is a graphical user interface for the computer algebra system
 Maxima. It eases the use of Maxima by making most of its commands available
 through a menu system and by providing input dialogs for commands that
 require more than one argument. It also implements its own display engine
 that outputs mathematical symbols directly instead of depicting them with
 ASCII characters.
 .
 wxMaxima also features 2D and 3D inline plots, simple animations, mixing of
 text and mathematical calculations to create documents, exporting of input
 and output to TeX, and a browser for Maxima's manual including command index
 and full text searching.
 .
 This package provides the documentation.
